#line 1 "F:/Electronics/Embeded/Interfacing External EEPROM with PIC Microcontroller/Interfacing External EEPROM with PIC Microcontroller.c"
void write_EEPROM(unsigned int address, unsigned int dat)
{
 unsigned int temp;
 I2C1_Start();
 I2C1_Wr(0xA0);
 temp = address >> 8;
 I2C1_Wr(temp);
 I2C1_Wr(address);
 I2C1_Wr(dat);
 I2C1_Stop();
 Delay_ms(20);
}

unsigned int read_EEPROM(unsigned int address)
{
 unsigned int temp;
 I2C1_Start();
 I2C1_Wr(0xA0);
 temp = address >> 8;
 I2C1_Wr(temp);
 I2C1_Wr(address);
 I2C1_Repeated_Start();
 I2C1_Wr(0xA1);
 temp = I2C1_Rd(0u);
 I2C1_Stop();
 return temp;
}

void main()
{
 unsigned int a, i;
 TRISB = 0;
 PORTB = 0;
 CMCON = 0x07;
 ADCON1 = 0x06;
 I2C1_Init(100000);
 do
 {
 for(i=0,a=1;i<8;i++)
 {
 write_EEPROM(i, a);
 Delay_ms(30);
 a = a<<1;
 }

 for(i=0;i<8;i++)
 {
 PORTB = read_EEPROM(i);
 Delay_ms(1000);
 }
 }while(1);
}
